from die import Die
from tqdm import tqdm

class FiveDice:
    def __init__(self):
        self.dice = [Die() for number in range(5)]

    def roll(self):
        for die in self.dice:
            die.roll()
        return self.faces()

    def faces(self):
        return [die.face for die in self.dice]

    def all_ones(self):
        for face in self.faces():
            if face != 1:
                return False
        return True
    
    def is_three_of_a_kind(self):
        if sum([d.face == self.dice[0].face for d in self.dice]) == 3:
            return True
        if sum([d.face == self.dice[1].face for d in self.dice]) == 3:
            return True
        if sum([d.face == self.dice[2].face for d in self.dice]) == 3:
            return True
        return False
    
    def is_four_of_a_kind(self):
        if sum([d.face == self.dice[0].face for d in self.dice]) == 4:
            return True
        if sum([d.face == self.dice[1].face for d in self.dice]) == 4:
            return True
        return False
        

dice = FiveDice()
successes = 0
trials = 1000000
for trial in tqdm(range(trials)):
    dice.roll()
    if dice.is_four_of_a_kind():
        successes += 1

print(successes/trials)
    


